unit GCAll;

interface

uses
	GC;

implementation

uses
	Windows;

function GCGetMem(Size: Integer): Pointer;
begin
	Result := GC_malloc(Size)
end;

function GCFreeMem(P: Pointer): Integer;
begin
	GC_free(P);
	Result := 0;
end;

function GCReallocMem(P: Pointer; Size: Integer): Pointer;
begin
	Result := GC_realloc(P, Size)
end;

const
	GCMemoryManager: TMemoryManager = (
		GetMem: GCGetMem;
		FreeMem: GCFreeMem;
		ReallocMem: GCReallocMem);

procedure InstallGC;
var
	TObjectVMT: Pointer;
	NewInstanceVMT: PPointer;
	FreeInstanceVMT: PPointer;
	OldProtect, Dummy: DWORD;
	BeginThread: Pointer;
begin
	//TObject̃ǗTGCObjectŏ
	TObjectVMT := Pointer(TObject);

	NewInstanceVMT := Pointer(Integer(TObjectVMT) + vmtNewInstance);
	VirtualProtect(NewInstanceVMT, 4, PAGE_READWRITE, OldProtect);
	NewInstanceVMT^ := @TGCObject.NewInstance;
	VirtualProtect(NewInstanceVMT, 4, OldProtect, Dummy);

	FreeInstanceVMT := Pointer(Integer(TObjectVMT) + vmtFreeInstance);
	VirtualProtect(FreeInstanceVMT, 4, PAGE_READWRITE, OldProtect);
	FreeInstanceVMT^ := @TGCObject.FreeInstance;
	VirtualProtect(FreeInstanceVMT, 4, OldProtect, Dummy);

	//System.BeginThreadGC.BeginThreadŏ
	BeginThread := @System.BeginThread;
	VirtualProtect(BeginThread, 5, PAGE_READWRITE, OldProtect);
	PByte(BeginThread)^ := $e9; {jmp}
	PInteger(Integer(BeginThread) + 1)^ := Integer(@GC.BeginThread) - Integer(BeginThread) - 5;
	VirtualProtect(BeginThread, 5, OldProtect, Dummy);

	//}l[Wu
	SetMemoryManager(GCMemoryManager);
end;

initialization

	InstallGC

end.
